//+------------------------------------------------------------------+
//|                                                   Break_Even.mq4 |
//|                                                         Zen_Leow |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Zen_Leow"
#property link      ""

extern int ticket = 0;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
//----
   if (ticket <= 0) // no orders defined, break even them all
   {
      int total = OrdersTotal();
      int positionType;
      if (total >= 0)
      {
         for(int cnt=0;cnt<total;cnt++)
         {
            if(OrderSelect(cnt,SELECT_BY_POS))
            {
               if (OrderType() == OP_BUY)
               {
                  if (OrderStopLoss() < OrderOpenPrice())
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                  }
               }
               if (OrderType() == OP_SELL)
               {
                  if (OrderStopLoss() > OrderOpenPrice())
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                  }
               }
            }
         }
      }
   }
   else // specific order defined for breakeven
   {
      if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
         if (OrderType() == OP_BUY)
         {
            if (OrderStopLoss() < OrderOpenPrice())
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
            }
         }
         if (OrderType() == OP_SELL)
         {
            if (OrderStopLoss() > OrderOpenPrice())
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
            }
         }
      }
      else
      {
         Alert("Ticket number does NOT exits in trade pool. Check again");
      }
   }
//----
   return(0);
}

//+------------------------------------------------------------------+