//+------------------------------------------------------------------+
//|                                                     CloseAll.mq4 |
//|  Version 2.01  (22-July-2011)                                    |
//|                                                       CodersGuru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+

#property copyright "CodersGuru"
#property link      "http://www.xpworx.com"
#property show_inputs

extern int option = 0;
//+------------------------------------------------------------------+
extern string a= "Set this prameter to the type of clsoing you want:";
extern string b= " 0- Close all (instant and pending orders) (Default)";
extern string c= " 1- Close all instant orders";
extern string d= " 2- Close all pending orders";
extern string e= " 3- Close by the magic number";
extern string f= " 4- Close by comment";
extern string g= " 5- Close orders in profit";
extern string h= " 6- Close orders in loss";
extern string i= " 7- Close not today orders";
extern string j= " 8- Close before day orders";
//+------------------------------------------------------------------+
extern int magic_number = 0; // set it if you'll use closing option 3 - closing by magic number
extern string comment_text = ""; // set it if you'll use closing option 4 - closing by comment
extern int before_day = 0; // set it if you'll use closing option 8 - closing by before day
//+------------------------------------------------------------------+
int init()
{
   if(magic_number>0) option=3;
   if(comment_text!="") option=4;
   if(before_day>0) option=8;
   
   return(0);
}

int start()
{
   CloseAll();
   return(0);
}
//+------------------------------------------------------------------+

int CloseAll()
{
   int total = OrdersTotal();
   int cnt = 0;
 
   switch (option)
   {
      case 0:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(Symbol()!=OrderSymbol()) RefreshRates();
            if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
            if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
            if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
         }
         break;
      }
      case 1:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(Symbol()!=OrderSymbol()) RefreshRates();
            if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
            if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
         }
         break;
      }
      case 2:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
         }
         break;
      }
      case 3:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if (OrderMagicNumber() == magic_number)
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }
      case 4:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if (strstr(OrderComment(),comment_text))
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }      
      case 5:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(OrderProfit() > 0)
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }            
      case 6:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(OrderProfit() < 0)
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }            
      case 7:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(TimeDay(OrderOpenTime())!=TimeDay(TimeCurrent()))
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }   
      case 8:
      {
         for (cnt = total ; cnt >=0 ; cnt--)
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(TimeDay(OrderOpenTime())<before_day)
            {
               if(Symbol()!=OrderSymbol()) RefreshRates();
               if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
               if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
               if(OrderType()>OP_SELL) OrderDelete(OrderTicket());
           }
         }         
         break;
      }                           
   }
}

bool strstr(string data, string what)
{
   if(StringFind(data,what,0)>-1) return(true);
   return(false);
}

