//+------------------------------------------------------------------+
//|          Free and OpenSource code under MIT License              |
//|              (https://opensource.org/licenses/MIT)               |
//|                 Copyright 2018 penyuperwira                      |
//|          (https://www.forexfactory.com/penyuperwira)             |
//|                  updated : 30.06.2018                            |
//+------------------------------------------------------------------+

#property copyright "SELL at market with TP/SL"


#property show_inputs

extern string info="If 'lots' is set to 0, it will try to use the 'ordersize' GlobalVariable(F3)";
extern double start_lot=0.01;
extern double SLpips = 0;
extern double TPpips = 39;
//extern int    MagicNumber=274693;
extern string    Use_MM_lots="IF you want to decrease lot by Equity";
extern string    Enable_MM_Percentage_Lots="set Mode_Lots = [2]";
extern bool       Mode_MM_Lots=true;
extern double     MM_Risk_Percent_Lots=0.25;
extern double     MM_Lot_Digits_Decimal=2;
extern bool      ProfitPercen= true;
extern double    ProfitPercent=1;
//extern bool      StopPercen=false;
//extern double    StopPercent=0.5;
#include <stdlib.mqh>

double pip;
int digits;
double Credit;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int err;

   getpip();
   Credit=AccountCredit();
   double ProfitPercentage=(AccountBalance()+Credit) *(ProfitPercent/100);
   double pipsMath=NormalizeDouble((ProfitPercentage)/(GetLots()/10),0);
   if(start_lot==0) start_lot = GlobalVariableGet("ordersize");
   if(start_lot==0) 
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }

   double SLprice=0;
   double TPprice=0;
   double Price=Bid;
   if(SLpips!=0) SLprice = Price+SLpips*pip;
   if(!ProfitPercen&&TPpips!=0) TPprice = Price-TPpips*pip;
 //if(ProfitPercen&&SLpips!=0) SLprice = Price+pipsMath*pip;
   if(ProfitPercen&&TPpips!=0) TPprice = Price-pipsMath*pip;
   int ticket=OrderSend(Symbol(),OP_SELL,GetLots(),Price,30,SLprice,TPprice,"",0,0,Green);

   if(ticket<0)
     {
      err=GetLastError();
      Alert(Symbol()+":SELL FAILED ("+err+"): "+ErrorDescription(err));
        } else {
      Alert(Symbol()+":SELL at "+DoubleToStr(Price,Digits)+" TP="+DoubleToStr(TPprice,Digits)+",SL="+DoubleToStr(SLprice,Digits));
     }

   Alert("--- END "+WindowExpertName()+" "+Symbol());

   return(0);
  }
//+------------------------------------------------------------------+

//--------------------------------------------------------------------------------------
// getpip
//--------------------------------------------------------------------------------------

void getpip()
  {
   if(Digits==2 || Digits==4) pip=Point;
   else if(Digits==3 || Digits==5) pip = 10*Point;
   else if(Digits==6) pip = 100*Point;

   if(Digits==3 || Digits==2) digits=2;
   else digits=4;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/* getpip*/

//end
//+------------------------------------------------------------------+
//|                       Money Management                           |
//+------------------------------------------------------------------+
//
double GetLots()
  {
   double MM_minlot = MarketInfo(Symbol(), MODE_MINLOT);
   double MM_maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   double MM_leverage= AccountLeverage();
   double MM_lotsize = MarketInfo(Symbol(),MODE_LOTSIZE);
   double MM_stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double xecn=1; if(Digits==5 || Digits==3){xecn=10;}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(Mode_MM_Lots)
     {
      double MM_lots;
      //MM_lots = NormalizeDouble(AccountFreeMargin() * MM_Risk_Percent_Lots/100 / 1000.0, MM_Lot_Digits_Decimal);
      //MM_lots = MathFloor((AccountFreeMargin() *AccountLeverage()*MM_Risk_Percent_Lots*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LotSIZE)*MarketInfo(Symbol(),MODE_MINLOT )))*MarketInfo(Symbol(),MODE_MINLOT );
      MM_lots=NormalizeDouble((AccountFreeMargin()*MM_leverage*MM_Risk_Percent_Lots*Point*xecn*100/(Ask*MM_lotsize*MM_minlot)*MM_minlot),MM_Lot_Digits_Decimal);
      if(MM_lots < MM_minlot) MM_lots = MM_minlot;
      if(MM_lots > MM_maxlot) MM_lots = MM_maxlot;
      if(AccountFreeMargin()<Ask*MM_lots*MM_lotsize/MM_leverage)
        {
         Print("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
         Comment("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
        }
     }
   else MM_lots=NormalizeDouble(start_lot,Digits);
   return(MM_lots);
  }
//+------------------------------------------------------------------+
